function init(hero) {
    hero.setName("Hexios");
    hero.setTier(6);

    hero.setHelmet("Hood");
    hero.setChestplate("item.superhero_armor.piece.robes");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("smp:magic");
    hero.addAttribute("PUNCH_DAMAGE", 4, 0);
    hero.addAttribute("JUMP_HEIGHT", 2, 0);
    hero.addAttribute("FALL_RESISTANCE", 6, 0);

    hero.addKeyBind("ENERGY_PROJECTION", "key.energyProjection", 1);
    hero.addKeyBind("SPELL_MENU", "key.spellMenu", 2);
    hero.addKeyBind("SHIELD", "key.forcefield", 3);
    hero.addKeyBind("CHARGED_BEAM", "Heal Blast", 4);
    hero.addKeyBind("AIM", "Power Dampen Spell", 5);

    hero.supplyFunction("canAim", canAim);
    hero.addAttributeProfile("SHIELD", shieldProfile);
    hero.setAttributeProfile(getAttributeProfile);
    hero.setKeyBindEnabled(isKeyBindEnabled);
}

function shieldProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("BASE_SPEED", -0.75, 1);
    profile.addAttribute("JUMP_HEIGHT", -2.0, 1);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:shield_blocking") ? "SHIELD" : null;
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "SHIELD":
        return entity.getHeldItem().isEmpty() && !entity.getData("fiskheroes:flying") && !entity.getData("fiskheroes:energy_projection") && entity.getData("fiskheroes:aiming_timer") == 0;
    case "CHARGED_BEAM":
        return !entity.getData("fiskheroes:energy_projection") && entity.getData("fiskheroes:aiming_timer") == 0;
    case "ENERGY_PROJECTION":
        return entity.getData("fiskheroes:beam_charge") == 0;
    case "HEAT_VISION":
        var aiming = (entity.getData("fiskheroes:aiming_timer") + entity.getData("fiskheroes:aimed_timer")) / 2;
        return aiming == 1;
    default:
        return true;
    }
}

function canAim(entity) {
    return entity.getHeldItem().isEmpty();
}