function init(hero) {
    hero.setName("Icelight");
    hero.setTier(4);

    hero.setChestplate("item.superhero_armor.piece.robes");

    hero.addPowers("smp:ice_manipulation");
    hero.addAttribute("PUNCH_DAMAGE", 4.0, 0);
    hero.addAttribute("WEAPON_DAMAGE", 1.0, 0);
    hero.addAttribute("JUMP_HEIGHT", 0.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 4.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.1, 1);

    hero.addKeyBind("CHARGE_ICE", "key.chargeIce", 1);
    hero.addKeyBind("BLADE", "Toggle Ice Staff", 5);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);

    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.setAttributeProfile(getAttributeProfile);
    hero.setDamageProfile(getAttributeProfile);
    hero.addDamageProfile("BLADE", {
        "types": {
            "SHARP": 1.0,
            "COLD": 0.4
        }
    });

    hero.setTickHandler((entity, manager) => {
        if (!entity.getData("blade")) {
            manager.setData(entity, "fiskheroes:cryo_charge", 0);
        }
    });
}

function bladeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 6.0, 0);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:blade") ? "BLADE" : null;
}

function isModifierEnabled(entity, modifier) {
    switch (modifier.name()) {
        case "fiskheroes:icicles":
            return entity.getData("fiskheroes:cryo_charge") < 1;
        case "fiskheroes:cryoball":
            return entity.getData("fiskheroes:cryo_charge") == 1;
        default:
            return true;
    }
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "CHARGE_ICE":
        return entity.getData("fiskheroes:blade");
    case "BLADE":
        return entity.getHeldItem().isEmpty();
    default:
        return true;
    }
}
