var utils = implement("fiskheroes:external/utils");

function init(hero) {
    hero.setName("Infinity Ultron");
    hero.setTier(10);

    hero.setHelmet("item.superhero_armor.piece.head");
    hero.setChestplate("item.superhero_armor.piece.torso");
    hero.setLeggings("item.superhero_armor.piece.legs");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("fiskheroes:vibranium_physiology", "smp:lance", "smp:power_stone", "fiskheroes:mind_stone", "smp:space_stone");
    hero.addAttribute("PUNCH_DAMAGE", 11.0, 0);
    hero.addAttribute("WEAPON_DAMAGE", 1.5, 0);
    hero.addAttribute("SPRINT_SPEED", 0.15, 1);
    hero.addAttribute("JUMP_HEIGHT", 1.0, 0);
    hero.addAttribute("FALL_RESISTANCE", 1.0, 1);

    hero.addKeyBind("CHARGED_BEAM", "key.mindStoneBlast", 1);
    hero.addKeyBind("INTANGIBILITY", "key.intangibility", 2);
    hero.addKeyBind("BLADE", "Toggle Lance", 2);
    hero.addKeyBind("TELEKINESIS", "key.telekinesis", 3);
    hero.addKeyBind("SHIELD", "key.forcefield", 4);
    hero.addKeyBind("ENERGY_PROJECTION", "Power Stone Blast", 5);

    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setModifierEnabled(isModifierEnabled);
    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.setAttributeProfile(getProfile);
    hero.setDamageProfile(getProfile);
    hero.addDamageProfile("BLADE", {"types": {"SHARP": 1.0}});

    hero.setHasProperty((entity, property) => property == "MASK_TOGGLE");
    hero.setDefaultScale(1.2);

    hero.setTickHandler((entity, manager) => {
        utils.flightOnIntangibility(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    if (entity.getData("fiskheroes:mask_open")) {
        return false;
    }

    switch (keyBind) {
    case "INTANGIBILITY":
        return !entity.isSneaking();
    case "BLADE":
        return entity.isSneaking();
    case "TELEKINESIS":
        return entity.getData("fiskheroes:beam_charge") == 0 && !entity.getData("fiskheroes:energy_projection");
    case "ENERGY_PROJECTION":
        return entity.getData("fiskheroes:beam_charge") == 0;
    case "CHARGED_BEAM":
        return !entity.getData("fiskheroes:energy_projection");
    case "SHIELD":
        return entity.getHeldItem().isEmpty() && !(entity.getData("fiskheroes:flying") && entity.isSprinting()) && !entity.getData("fiskheroes:telekinesis") && !entity.getData("fiskheroes:mask_open") && entity.getData("fiskheroes:beam_charge") == 0 && !entity.getData("fiskheroes:energy_projection");
    default:
        return true;
    }
}

function isModifierEnabled(entity, modifier) {
    switch (modifier.name()) {
        case "fiskheroes:controlled_flight":
            return !entity.getData("fiskheroes:mask_open");
        default:
            return true;
    }
}

function bladeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 13.0, 0);
}

function getProfile(entity) {
    return entity.getData("fiskheroes:blade") ? "BLADE" : null;
}
