var landing = implement("fiskheroes:external/superhero_landing");

function init(hero) {
    hero.setName("Redstone Mech");
    hero.setTier(6);

    hero.setHelmet("item.superhero_armor.piece.helmet");
    hero.setChestplate("item.superhero_armor.piece.chestplate");
    hero.setLeggings("item.superhero_armor.piece.leggings");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("smp:redstone_mech");
    hero.addAttribute("PUNCH_DAMAGE", 7.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.15, 1);
    hero.addAttribute("JUMP_HEIGHT", 0.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 7.0, 0);

    hero.addKeyBind("SIZE_MANIPULATION", "key.sizeManipulation", 1);
    hero.addKeyBind("AIM", "key.aim", 2);
    hero.addKeyBind("UTILITY_BELT", "key.grenades", 3);
    hero.addKeyBindFunc("func_TOGGLE_FLIGHT", (player, manager) => {
        manager.setData(player, "fiskheroes:dyn/nanites", !player.getData("fiskheroes:dyn/nanites"));
        return true;
    }, "Toggle Flight", 5);

    hero.supplyFunction("canAim", canAim);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setModifierEnabled(isModifierEnabled);
    hero.setHasProperty(hasProperty);

    hero.setTickHandler((entity, manager) => {
        var flying = entity.getData("fiskheroes:flying");
        manager.incrementData(entity, "fiskheroes:dyn/booster_timer", 2, flying);

        var item = entity.getHeldItem();
        flying &= !entity.as("PLAYER").isUsingItem();
        manager.incrementData(entity, "fiskheroes:dyn/booster_r_timer", 2, flying && item.isEmpty() && !entity.isPunching() && entity.getData("fiskheroes:aiming_timer") == 0);
        manager.incrementData(entity, "fiskheroes:dyn/booster_l_timer", 2, flying && !item.doesNeedTwoHands());

        landing.tick(entity, manager);

        if (entity.getData("fiskheroes:dyn/nanites")) {
            hero.setName("Redstone Mech (FD)");
        }
        else {
            hero.setName("Redstone Mech");
        }
    });
}

function isKeyBindEnabled(entity, keyBind) {
        switch (keyBind) {
        case "AIM":
            return entity.getData("fiskheroes:scale") == 1
        case "UTILITY_BELT":
            return entity.getWornChestplate().nbt().getString("HeroType") == "smp:redstone_mech";
        case "func_TOGGLE_FLIGHT":
            return entity.getWornChestplate().nbt().getString("HeroType") == "smp:redstone_mech/speedburst";
        default:
            return true;
    }
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() == "fiskheroes:controlled_flight") {
        return entity.getWornChestplate().nbt().getString("HeroType") == "smp:redstone_mech" ? true : entity.getWornChestplate().displayName() == "Redstone Mech's Chestplate";
    }
    return true;
}

function canAim(entity) {
    return entity.getHeldItem().isEmpty();
}

function hasProperty(entity, property) {
    return property == "MASK_TOGGLE" || property == "BREATHE_SPACE" && !entity.getData("fiskheroes:mask_open");
}