var speedster_base = implement("fiskheroes:external/speedster_base");

function init(hero) {
    hero.setName("Roserush");
    hero.setTier(6);

    hero.setHelmet("item.superhero_armor.piece.cowl");
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");
    hero.addEquipment("fiskheroes:flash_ring");

    hero.addPowers("smp:roserush");
    hero.addAttribute("PUNCH_DAMAGE", 5.0, 0);
    hero.addAttribute("WEAPON_DAMAGE", 1.5, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.0, 0);
    hero.addAttribute("FALL_RESISTANCE", 4.0, 0);
    hero.addAttribute("BASE_SPEED_LEVELS", 6.0, 0);

    hero.addKeyBind("ENERGY_PROJECTION", "Speed Knockback", -2);
    hero.addKeyBind("CHARGE_ENERGY", "key.chargeEnergy", -2);
    hero.addKeyBind("SUPER_SPEED", "key.superSpeed", 1);
    hero.addKeyBind("SLOW_MOTION", "key.slowMotion", 2);

    var speedPunch = speedster_base.createSpeedPunch(hero);
    hero.setDamageProfile(entity => speedPunch.get(entity, null));

    hero.addSoundEvent("EQUIP", ["fiskheroes:flicker_loop_zoom", "fiskheroes:flicker_loop_zoom_pink"]);

    hero.setTickHandler((entity, manager) => {
        speedster_base.tick(entity, manager);

        manager.setData(entity, "fiskheroes:energy_projection", entity.getData("fiskheroes:speed_sprinting") && entity.getData("fiskheroes:speed") > 1);
        manager.setDataWithNotify(entity, "fiskheroes:energy_charging", entity.getData("fiskheroes:speed_sprinting"));
    });
}
