extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:currentconductor_layer1",
    "layer2": "smp:currentconductor_layer2",
    "shield": "smp:currentconductor_shield",
});

var utils = implement("fiskheroes:external/utils");
var speedster = implement("fiskheroes:external/speedster_utils");

var shield;

function initEffects(renderer) {

    var beam = renderer.createResource("BEAM_RENDERER", "smp:charged_beam");
    utils.bindBeam(renderer, "fiskheroes:energy_projection", beam, "rightArm", 0x52E6FB, [
        { "firstPerson": [-3.75, 3.0, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [1.5, 1.5] },
        { "firstPerson": [3.75, 3.0, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [1.5, 1.5], "anchor": "leftArm" }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_charged_beam"));

    utils.bindBeam(renderer, "fiskheroes:charged_beam", null, "body", null, []);

    shield = renderer.createEffect("fiskheroes:shield");
    shield.texture.set("shield");
    shield.anchor.set("rightArm");
    shield.setRotation(0.0, 0.0, -10.0).setCurve(15.0, 50.0);
    shield.large = true;

    burst_charge = renderer.bindProperty("fiskheroes:trail");
    burst_charge.setTrail(renderer.createResource("TRAIL", "smp:current_charge"));
    burst_charge.setCondition(entity => entity.getData("fiskheroes:beam_charging"));

    burst = renderer.bindProperty("fiskheroes:trail");
    burst.setTrail(renderer.createResource("TRAIL", "smp:current_burst"));
    burst.setCondition(entity => entity.getData("fiskheroes:beam_charge") > 0.9);

    var trail = renderer.bindProperty("fiskheroes:trail");
    trail.setTrail(renderer.createResource("TRAIL", "smp:lightning_conductor")).setCondition(entity => entity.getData("fiskheroes:flying") && !entity.getData("fiskheroes:beam_charging"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.CHARGED_BEAM");
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");

    addAnimationWithData(renderer, "basic.ENERGY_PROJ", "fiskheroes:dual_aiming", "fiskheroes:energy_projection_timer");

    utils.addFlightAnimation(renderer, "current.FLIGHT", "fiskheroes:flight/default.anim.json");
    utils.addHoverAnimation(renderer, "current.HOVER", "fiskheroes:flight/idle/default");
}

function render(entity, renderLayer, isFirstPersonArm) {
    shield.unfold = entity.getInterpolatedData("fiskheroes:shield_timer");
    shield.setOffset(2.9 + 1.8 * Math.min(shield.unfold * 5, 1), 6.0, 0.0);
    shield.render();
}