extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:deadzone_layer1",
    "layer2": "smp:deadzone_layer2",
    "wings": "smp:deadzone_wings",
    "dagger": "smp:deadzone_dagger",
    "fire": "smp:deadzone_dagger.tx.json",
    "eyes": "smp:deadzone_eyes"
});

var utils = implement("fiskheroes:external/utils");

var wings;

function initEffects(renderer) {
    dagger = renderer.createEffect("fiskheroes:model");
    dagger.setModel(utils.createModel(renderer, "smp:deadzone_dagger", "dagger", "fire"));
    dagger.anchor.set("rightArm");
    dagger.setRotation(90, 0, 0);
    dagger.setOffset(1, 8.5, -21.5)

    var forcefield = renderer.bindProperty("fiskheroes:forcefield");
    forcefield.color.set(0x5ABBBB);
    forcefield.setShape(36, 18).setOffset(0.0, 6.0, 0.0).setScale(1.25);
    forcefield.setCondition(entity => {
        forcefield.opacity = entity.getInterpolatedData("fiskheroes:shield_blocking_timer") * 0.15;
        return true;
    });

    utils.bindBeam(renderer, "fiskheroes:energy_projection", null, "body", 0xFFFFFF, []);

    wings = renderer.createEffect("fiskheroes:wingsuit");
    wings.texture.set("wings");

    eyes = renderer.createEffect("fiskheroes:overlay");
    eyes.texture.set(null, "eyes");

    utils.bindCloud(renderer, "fiskheroes:particle_cloud", "smp:deadzone").setCondition(entity => entity.getData("fiskheroes:shadowform"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");
    
    addAnimation(renderer, "basic.CHARGED_BEAM", "fiskheroes:aiming").setData((entity, data) => data.load(Math.max(entity.getInterpolatedData("fiskheroes:beam_charge") * 5 - 4, 0)));

    addAnimationWithData(renderer, "deadzone.SPRINT", "fiskheroes:speedster_sprint", "smp:dyn/sprint_timer").priority = -1;
    addAnimationWithData(renderer, "deadzone.DAGGER_POSE", "smp:dagger_pose", "smp:dyn/dagger_timer");
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (renderLayer == "HELMET") {
        eyes.opacity = entity.getInterpolatedData("fiskheroes:mask_open_timer2");
        eyes.render();
    }
    else if (renderLayer == "CHESTPLATE") {
        if (entity.getData("fiskheroes:blade")) {
            dagger.render();
        }
        if (!isFirstPersonArm) {
            wings.unfold = entity.getInterpolatedData("fiskheroes:wing_animation_timer");
        wings.render();
        }
    }
}
