extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:kade_killious_layer1",
    "layer2": "smp:kade_killious_layer2",
    "axe": "smp:kade_killious_axe",
    "wall": "smp:kade_killious_wall"
});

var utils = implement("fiskheroes:external/utils");

function initEffects(renderer) {
    axe = renderer.createEffect("fiskheroes:model");
    axe.setModel(utils.createModel(renderer, "smp:kade_killious_axe", null, "axe"));
    axe.anchor.set("rightArm");
    axe.setRotation(90, 0, 0);
    axe.setOffset(1, 8.5, -19.5)

    wall = renderer.createEffect("fiskheroes:model");
    wall.setModel(utils.createModel(renderer, "smp:kade_killious_wall", null, "wall"));
    wall.anchor.set("body");
    wall.setOffset(0, 0, -20);

    utils.bindCloud(renderer, "fiskheroes:telekinesis", "smp:kade_killious");

    utils.bindBeam(renderer, "fiskheroes:energy_projection", "fiskheroes:mysterio_beam", "rightArm", 0xFF1919, [
        { "firstPerson": [-5.5, 4.75, -10.0], "offset": [-0.5, 9.0, 0.0], "size": [2.0, 2.0] },
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");
    renderer.removeCustomAnimation("basic.BLOCKING");

    addAnimationWithData(renderer, "kade.ENERGY_PROJ", "fiskheroes:aiming", "fiskheroes:energy_projection_timer");

    addAnimationWithData(renderer, "kade.BLOCKING", "fiskheroes:dual_aiming", "fiskheroes:shield_blocking_timer");

    utils.addFlightAnimation(renderer, "kade.FLIGHT", "fiskheroes:flight/martian_comics.anim.json");
    utils.addHoverAnimation(renderer, "kade.HOVER", "fiskheroes:flight/idle/martian_comics");
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (renderLayer == "CHESTPLATE") {
        axe.opacity = 0.85 * entity.getInterpolatedData("fiskheroes:blade_timer");
        axe.render();

        if (isFirstPersonArm) {
            wall.setRotation(-entity.rotPitch(), 0, 0);
            wall.anchor.ignoreAnchor(true);
        } else {
            wall.setRotation(0, 0, 0);
            wall.anchor.ignoreAnchor(false);
        }

        wall.opacity = 0.85 * entity.getInterpolatedData("fiskheroes:shield_blocking_timer");
        wall.render();
    }
}