extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:phantom_knight_layer1",
    "layer2": "smp:phantom_knight_layer2",
    "fab1": "smp:phantom_knight_s2_layer1",
    "fab2": "smp:phantom_knight_s2_layer2",
    "sword": "smp:phantom_knight_sword.tx.json"
});

var utils = implement("fiskheroes:external/utils");

var blade;

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        if (entity.as("DISPLAY").getDisplayType() === "FABRICATOR_PREVIEW" || entity.as("DISPLAY").getDisplayType() === "FABRICATOR_RESULT") {
            return renderLayer == "LEGGINGS" ? "fab2" : "fab1";
        }
        return renderLayer == "LEGGINGS" ? "layer2" : "layer1";
    });
}

function initEffects(renderer) {
    sword = renderer.createEffect("fiskheroes:model");
    sword.setModel(utils.createModel(renderer, "smp:phantom_knight_sword", "sword"));
    sword.anchor.set("rightArm");
    sword.setRotation(90, 90, 0);
    sword.setOffset(1, 8.5, -21.5)

    utils.setOpacityWithData(renderer, 0.0, 1.0, "fiskheroes:shadowform_timer");

    utils.bindCloud(renderer, "fiskheroes:particle_cloud", "fiskheroes:shadow_smoke").setCondition(entity => entity.getData("fiskheroes:shadowform"));
    utils.bindCloud(renderer, "fiskheroes:telekinesis", "fiskheroes:shadow_smoke");

    utils.bindParticles(renderer, "smp:phantom_smoke").setCondition(entity => entity.getData("fiskheroes:flying"));

    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:dark_pulse", "rightArm", 0x070606, [
        { "firstPerson": [-4.5, 3.75, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [2.5, 2.5] }
    ]);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.BLOCKING");
    renderer.removeCustomAnimation("basic.CHARGED_BEAM");

    addAnimationWithData(renderer, "phantom.SWORD_POSE", "fiskheroes:sword_pose", "fiskheroes:blade_timer");

    addAnimationWithData(renderer, "phantom.ANTIBLAST", "fiskheroes:aiming", "fiskheroes:beam_charge");

    utils.addFlightAnimation(renderer, "phantom.FLIGHT", "fiskheroes:flight/default.anim.json");
    utils.addHoverAnimation(renderer, "phantom.HOVER", "fiskheroes:flight/idle/default");
}

function render(entity, renderLayer, isFirstPersonArm) {
    sword.opacity = entity.getInterpolatedData("fiskheroes:blade_timer");
    sword.render();
}
