extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:quantum_mech_layer1",
    "layer2": "smp:quantum_mech_layer2",
    "lights1": "smp:quantum_mech_light_layer1",
    "lights2": "smp:quantum_mech_light_layer2"
});

var utils = implement("fiskheroes:external/utils");
var boosters = implement("smp:external/redstone_mech_boosters");

var booster;

function init(renderer) {
    parent.init(renderer);
    renderer.setLights((entity, renderLayer) => {
        return renderLayer == "LEGGINGS" ? "lights2" : "lights1";
    });
}

function initEffects(renderer, entity) {
    boosters = boosters.create(renderer, "fiskheroes:deep_blue_fire_layer_%s", true);

    utils.addCameraShake(renderer, 0.015, 1.5, "fiskheroes:flight_boost_timer");

    utils.bindBeam(renderer, "fiskheroes:energy_projection", "smp:heal", "rightArm", 0x30AAD5, [
        { "firstPerson": [-4.5, 3.75, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [2, 2] }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));

    renderer.bindProperty("fiskheroes:energy_bolt").color.set(0x30AAD5);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");
    
    utils.addFlightAnimationWithLanding(renderer, "iron_man.FLIGHT", "fiskheroes:flight/iron_man.anim.json");
    utils.addHoverAnimation(renderer, "iron_man.HOVER", "fiskheroes:flight/idle/iron_man");
    addAnimationWithData(renderer, "rainbow.LAND", "fiskheroes:superhero_landing", "fiskheroes:dyn/superhero_landing_timer")
        .priority = -8;

    utils.addAnimationEvent(renderer, "FLIGHT_DIVE", "fiskheroes:iron_man_dive");
    
    addAnimationWithData(renderer, "rainbow.ROLL", "fiskheroes:flight/barrel_roll", "fiskheroes:barrel_roll_timer")
            .priority = 10;
}

function render(entity, renderLayer, isFirstPersonArm) {
    boosters.render(entity, renderLayer, isFirstPersonArm, false);
}