extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:revertax_layer1",
    "layer2": "smp:revertax_layer2",
    "eyes": "smp:cordaxe_eyes"
});

var utils = implement("fiskheroes:external/utils");
var speedster = implement("fiskheroes:external/speedster_utils");

function init(renderer) {
    parent.init(renderer);
    renderer.setLights((entity, renderLayer) => {
        return renderLayer == "HELMET" ? "eyes" : null;
    });
}

function initEffects(renderer, entity) {
    speedster.init(renderer);

    utils.bindTrail(renderer, "smp:lightning_cordaxe");

    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:lightning_sword_cast", "rightArm", 0xFF0000, [
        { "firstPerson": [-5.5, 4.75, -10.0], "offset": [-0.5, 9.0, 0.0], "size": [1.0, 1.0] }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));

    utils.bindBeam(renderer, "fiskheroes:energy_projection", null, "body", null, []);

    utils.bindParticles(renderer, "smp:critical_hand").setCondition(entity => entity.getData("smp:dyn/super_punch_timer") == 1);
    utils.bindParticles(renderer, "smp:super_sonic_punch").setCondition(entity => entity.getData("smp:dyn/super_punch_timer") == 1 && entity.isPunching());
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");

    addAnimation(renderer, "cordaxe.TORNADO", "smp:tornado_arms").setData((entity, data) => {
        data.load(0, entity.getData("smp:dyn/tornado_arms_timer"));
        data.load(1, entity.getData("fiskheroes:sonic_waves") ? entity.loop(3) : 0);
    });

    addAnimation(renderer, "cordaxe.LIGHTNING_BEAM", "fiskheroes:aiming_fpcorr").setData((entity, data) => data.load(Math.max(entity.getInterpolatedData("fiskheroes:beam_charge") * 5 - 4, 0)));
}