extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:the_rival_layer1",
    "layer2": "smp:the_rival_layer2",
    "book": "smp:the_rival_book"
});
var utils = implement("fiskheroes:external/utils");

function initEffects(renderer) {
    utils.bindBeam(renderer, "fiskheroes:charged_beam", "fiskheroes:mysterio_beam", "body", 0x00A894, [
        { "firstPerson": [0.0, 6.0, 0.0], "offset": [0.0, 2.5, -2.0], "size": [5.0, 5.0] }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_charged_beam"));

    var model = renderer.createResource("MODEL", "smp:entity_book");
    model.bindAnimation("smp:entity_book")
        .setData((entity, data) => {
            data.load(0, entity.getInterpolatedData("fiskheroes:beam_charge"));
        })
    model.texture.set("book");
    book = renderer.createEffect("fiskheroes:model").setModel(model);
    book.anchor.set("rightArm");
    book.setRotation(20, 180, 0);
    book.setScale(0.8);
    book.setOffset(0, -8, -10);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    utils.addFlightAnimationWithLanding(renderer, "rival.FLIGHT", "fiskheroes:flight/default.anim.json");
    utils.addHoverAnimation(renderer, "rival.HOVER", "fiskheroes:flight/idle/neutral");
    utils.addAnimationEvent(renderer, "FLIGHT_DIVE", "fiskheroes:iron_man_dive");

    addAnimationWithData(renderer, "rival.LAND", "fiskheroes:superhero_landing", "fiskheroes:dyn/superhero_landing_timer")
        .priority = -8;

    addAnimationWithData(renderer, "rival.CHARGE", "smp:the_rival_charge", "fiskheroes:beam_charge")
        .priority = -8;

    addAnimationWithData(renderer, "rival.ROLL", "fiskheroes:flight/barrel_roll", "fiskheroes:barrel_roll_timer")
        .priority = 10;
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (entity.getData("fiskheroes:beam_charge") > 0) {
        book.opacity = Math.min(entity.getInterpolatedData("fiskheroes:beam_charge") * 6, 1);
        book.render();
    }
}