extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:the_undying_layer1",
    "layer2": "smp:the_undying_layer2",
    "wings": "smp:the_undying_wings",
    "staff": "smp:the_undying_staff",
    "staff_lights": "smp:the_undying_staff_light",
});

var utils = implement("fiskheroes:external/utils");
var wing_utils = implement("fiskheroes:external/wing_utils");

var wings;

function initEffects(renderer) {
    wings = wing_utils.create(renderer, "wings", null, wing_utils.PRESET_CONTROLLED_FLIGHT);

    staff = renderer.createEffect("fiskheroes:model");
    staff.setModel(utils.createModel(renderer, "smp:the_undying_staff", "staff", "staff_lights"));
    staff.anchor.set("rightArm");
    staff.setRotation(90, 0, 0);
    staff.setOffset(1, 8, -6.5)

    utils.bindBeam(renderer, "fiskheroes:energy_projection", "fiskheroes:mysterio_beam", "rightArm", 0x77DA1F, [
        { "firstPerson": [-5.5, 0, -10.0], "offset": [-0.5, 9.0, -8], "size": [0.5, 0.5] },
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_energy_projection"));

    utils.bindBeam(renderer, "fiskheroes:energy_manipulation", "fiskheroes:energy_discharge", "rightArm", 0x77DA1F, [
        { "firstPerson": [-2.5, 0.0, -7.0], "offset": [-0.5, 9.0, -8.0], "size": [1.5, 1.5] }
    ]);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.AIMING");
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");

    addAnimationWithData(renderer, "basic.AIMING", "fiskheroes:aiming_fpcorr", "fiskheroes:aiming_timer");

    utils.addHoverAnimation(renderer, "falcon.HOVER", "fiskheroes:flight/idle/falcon");
    utils.addFlightAnimation(renderer, "falcon.FLIGHT", "fiskheroes:flight/falcon.anim.json", (entity, data) => {
        data.load(0, entity.getInterpolatedData("fiskheroes:flight_timer"));
        data.load(1, entity.getInterpolatedData("fiskheroes:flight_boost_timer"));
        data.load(3, entity.getInterpolatedData("fiskheroes:dyn/flight_super_boost_timer"));
    });
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (renderLayer == "CHESTPLATE") {
        wings.render(entity, entity.getInterpolatedData("fiskheroes:shield_blocking_timer"));

        if (entity.getData("fiskheroes:blade")) {
            staff.render();
        }
    }
}