extend("fiskheroes:hero_basic");
loadTextures({
    "suit": "smp:thundercrash",
    "null": "smp:null"
});

var utils = implement("fiskheroes:external/utils");

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        if (!entity.is("DISPLAY")) {
            var timer = entity.getInterpolatedData("smp:dyn/gamma_timer");
            return timer < 0 ? "null" : timer == 1 ? "suit" : "null";
        }
        return "suit";
    });

    renderer.showModel("CHESTPLATE", "head", "headwear", "body", "rightArm", "leftArm", "rightLeg", "leftLeg");
    renderer.fixHatLayer("CHESTPLATE");
}

function initEffects(renderer) {
    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:thunderclap", "body", 0x0059FF, [
        { "firstPerson": [0.0, 6.0, 0.0], "offset": [0.0, -5.0, -10.0], "size": [1.5, 1.5] }
    ]);

    utils.bindBeam(renderer, "fiskheroes:heat_vision", null, "head", null, []);

    transform = renderer.createEffect("fiskheroes:overlay");
    transform.texture.set("suit");

    utils.bindParticles(renderer, "smp:thundercrash_eyes").setCondition(entity => entity.getData("smp:dyn/gamma"));

    var trail = renderer.bindProperty("fiskheroes:trail");
    trail.setTrail(renderer.createResource("TRAIL", "smp:lightning_thundercrash")).setCondition(entity => entity.getData("smp:dyn/gamma"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);

    addAnimation(renderer, "thundercrash.THUNDERCLAP", "smp:thunderclap").setData((entity, data) => {
        data.load(entity.getInterpolatedData("fiskheroes:beam_charge"));
    });

    /*addAnimation(renderer, "basic.PUNCH", "smp:hulk_punch").setData((entity, data) => {
        data.load(entity.getData("smp:dyn/gamma") ? entity.getPunchTimerInterpolated() : 0);
    });*/

    addAnimation(renderer, "thundercrash.TRANSFORM", "smp:gamma_transform").setData((entity, data) => {
        data.load(entity.getData("smp:dyn/gamma") ? entity.getInterpolatedData("smp:dyn/gamma_timer") : 0);
    });

    addAnimation(renderer, "thundercrash.LEAP", "smp:thundercrash_leap") 
		.setData((entity, data) => {
		data.load(0, entity.getInterpolatedData("smp:dyn/leap_timer") - entity.getInterpolatedData("smp:dyn/superhero_landing_timer"));
    }).priority = 0;

    addAnimationWithData(renderer, "thundercrash.SMASH", "smp:thundercrash_slam", "smp:dyn/superhero_landing_timer")
        .priority = 1;
}

function render(entity, renderLayer, isFirstPersonArm) {
    var x = entity.getInterpolatedData("smp:dyn/gamma_timer");
    transform.opacity = entity.getData("smp:dyn/gamma") ? 0.025 * Math.sin(Math.PI * 16 * x) + x * x : x
    transform.render();
}
