extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:wavebreaker_layer1",
    "layer2": "smp:wavebreaker_layer2",
    "trident": "smp:wavebreaker_trident"
});

var utils = implement("fiskheroes:external/utils");

function initEffects(renderer) {
    trident = renderer.createEffect("fiskheroes:model");
    trident.setModel(utils.createModel(renderer, "smp:wavebreaker_trident", "trident"));
    trident.anchor.set("rightArm");
    trident.setRotation(90, 0, 0);
    trident.setOffset(1, 8, -8.5)

    vision = renderer.bindProperty("fiskheroes:night_vision");
    vision.factor = 10;
    vision.fogStrength = -10;
    vision.underwaterOnly = true;

    utils.bindParticles(renderer, "smp:wavebreaker_water").setCondition(entity => entity.getData("fiskheroes:flying"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    addAnimationWithData(renderer, "wavebreaker.ROLL", "fiskheroes:flight/barrel_roll", "fiskheroes:barrel_roll_timer")
        .priority = 10;

    utils.addFlightAnimation(renderer, "wavebreaker.FLIGHT", "fiskheroes:flight/default.anim.json");
    utils.addHoverAnimation(renderer, "wavebreaker.HOVER", "fiskheroes:flight/idle/default");
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (entity.getData("fiskheroes:blade")) {
        trident.render();
    }
}